"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var nil = exports.nil = "";

var get = exports.get = function get(pointer) {
  if (pointer.length > 0 && pointer[0] !== "/") {
    throw Error("Invalid JSON Pointer");
  }

  var ptr = pointer.split("/").slice(1).map(unescape);

  return function (value) {
    return ptr.reduce(function (_ref, segment) {
      var _ref2 = _slicedToArray(_ref, 2),
          value = _ref2[0],
          pointer = _ref2[1];

      return [applySegment(value, segment, pointer), append(pointer, segment)];
    }, [value, ""])[0];
  };
};

var append = exports.append = function append(pointer, segment) {
  return pointer + "/" + escape(segment);
};

var escape = function escape(segment) {
  return segment.toString().replace("~", "~0").replace("/", "~1");
};
var unescape = function unescape(segment) {
  return segment.toString().replace("~0", "~").replace("~1", "/");
};

var applySegment = function applySegment(value, segment) {
  var pointer = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "";

  if (value === null || (typeof value === "undefined" ? "undefined" : _typeof(value)) !== "object") {
    throw Error("Value at '" + pointer + "' is a scalar and can't be indexed");
  } else if (!(segment in value)) {
    throw Error("Value at '" + pointer + "' does not have index '" + segment + "'");
  }

  return value[segment];
};